require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_BITOPS_H)) {
    eval 'sub __ASM_SH_BITOPS_H () {1;}' unless defined(&__ASM_SH_BITOPS_H);
    if(defined(&__KERNEL__)) {
	require 'asm/system.ph';
	require 'asm/byteorder.ph';
	eval 'sub set_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask;  &volatile my $int * &a = $addr; my $flags;  &a += $nr >> 5;  &mask = 1<< ($nr & 0x1f);  &save_and_cli( $flags); * &a |=  &mask;  &restore_flags( $flags); });
	}' unless defined(&set_bit);
	eval 'sub __set_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask;  &volatile my $int * &a = $addr;  &a += $nr >> 5;  &mask = 1<< ($nr & 0x1f); * &a |=  &mask; });
	}' unless defined(&__set_bit);
	eval 'sub smp_mb__before_clear_bit () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__before_clear_bit);
	eval 'sub smp_mb__after_clear_bit () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__after_clear_bit);
	eval 'sub clear_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask;  &volatile my $int * &a = $addr; my $flags;  &a += $nr >> 5;  &mask = 1<< ($nr & 0x1f);  &save_and_cli( $flags); * &a &= ~ &mask;  &restore_flags( $flags); });
	}' unless defined(&clear_bit);
	eval 'sub __clear_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask;  &volatile my $int * &a = $addr;  &a += $nr >> 5;  &mask = 1<< ($nr & 0x1f); * &a &= ~ &mask; });
	}' unless defined(&__clear_bit);
	eval 'sub change_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask;  &volatile my $int * &a = $addr; my $flags;  &a += $nr >> 5;  &mask = 1<< ($nr & 0x1f);  &save_and_cli( $flags); * &a ^=  &mask;  &restore_flags( $flags); });
	}' unless defined(&change_bit);
	eval 'sub __change_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask;  &volatile my $int * &a = $addr;  &a += $nr >> 5;  &mask = 1<< ($nr & 0x1f); * &a ^=  &mask; });
	}' unless defined(&__change_bit);
	eval 'sub test_and_set_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask,  &retval;  &volatile my $int * &a = $addr; my $flags;  &a += $nr >> 5;  &mask = 1<< ($nr & 0x1f);  &save_and_cli( $flags);  &retval = ( &mask & * &a) != 0; * &a |=  &mask;  &restore_flags( $flags);  &retval; });
	}' unless defined(&test_and_set_bit);
	eval 'sub __test_and_set_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask,  &retval;  &volatile my $int * &a = $addr;  &a += $nr >> 5;  &mask = 1<< ($nr & 0x1f);  &retval = ( &mask & * &a) != 0; * &a |=  &mask;  &retval; });
	}' unless defined(&__test_and_set_bit);
	eval 'sub test_and_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask,  &retval;  &volatile my $int * &a = $addr; my $flags;  &a += $nr >> 5;  &mask = 1<< ($nr & 0x1f);  &save_and_cli( $flags);  &retval = ( &mask & * &a) != 0; * &a &= ~ &mask;  &restore_flags( $flags);  &retval; });
	}' unless defined(&test_and_clear_bit);
	eval 'sub __test_and_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask,  &retval;  &volatile my $int * &a = $addr;  &a += $nr >> 5;  &mask = 1<< ($nr & 0x1f);  &retval = ( &mask & * &a) != 0; * &a &= ~ &mask;  &retval; });
	}' unless defined(&__test_and_clear_bit);
	eval 'sub test_and_change_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask,  &retval;  &volatile my $int * &a = $addr; my $flags;  &a += $nr >> 5;  &mask = 1<< ($nr & 0x1f);  &save_and_cli( $flags);  &retval = ( &mask & * &a) != 0; * &a ^=  &mask;  &restore_flags( $flags);  &retval; });
	}' unless defined(&test_and_change_bit);
	eval 'sub __test_and_change_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask,  &retval;  &volatile my $int * &a = $addr;  &a += $nr >> 5;  &mask = 1<< ($nr & 0x1f);  &retval = ( &mask & * &a) != 0; * &a ^=  &mask;  &retval; });
	}' unless defined(&__test_and_change_bit);
	eval 'sub test_bit {
	    my($nr,$addr) = @_;
    	    eval q({ 1 & ((( &const  &volatile my $int *) $addr)[$nr >> 5] >> ($nr & 31)); });
	}' unless defined(&test_bit);
	eval 'sub ffz {
	    my($word) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&ffz);
	eval 'sub find_next_zero_bit {
	    my($addr,$size,$offset) = @_;
    	    eval q({ my $long * &p = ( $addr) + ($offset >> 5); my $result = $offset & ~31; my $tmp;  &if ($offset >= $size) $size; $size -=  $result; $offset &= 31;  &if ($offset) {  $tmp = *( &p++);  $tmp |= ~0 >> (32-$offset);  &if ($size < 32)  &goto  &found_first;  &if (~ $tmp)  &goto  &found_middle; $size -= 32;  $result += 32; }  &while ($size & ~31) {  &if (~( $tmp = *( &p++)))  &goto  &found_middle;  $result += 32; $size -= 32; }  &if (!$size)  $result;  $tmp = * &p;  &found_first:  $tmp |= ~0 << $size;  &found_middle:  $result +  &ffz( $tmp); });
	}' unless defined(&find_next_zero_bit);
	eval 'sub find_first_zero_bit {
	    my($addr, $size) = @_;
    	    eval q( &find_next_zero_bit(($addr), ($size), 0));
	}' unless defined(&find_first_zero_bit);
	eval 'sub ffs {
	    my($x) = @_;
    	    eval q( &generic_ffs($x));
	}' unless defined(&ffs);
	eval 'sub hweight32 {
	    my($x) = @_;
    	    eval q( &generic_hweight32($x));
	}' unless defined(&hweight32);
	eval 'sub hweight16 {
	    my($x) = @_;
    	    eval q( &generic_hweight16($x));
	}' unless defined(&hweight16);
	eval 'sub hweight8 {
	    my($x) = @_;
    	    eval q( &generic_hweight8($x));
	}' unless defined(&hweight8);
	if(defined(&__LITTLE_ENDIAN__)) {
	    eval 'sub ext2_set_bit {
	        my($nr, $addr) = @_;
    		eval q( &test_and_set_bit(($nr), ($addr)));
	    }' unless defined(&ext2_set_bit);
	    eval 'sub ext2_clear_bit {
	        my($nr, $addr) = @_;
    		eval q( &test_and_clear_bit(($nr), ($addr)));
	    }' unless defined(&ext2_clear_bit);
	    eval 'sub ext2_test_bit {
	        my($nr, $addr) = @_;
    		eval q( &test_bit(($nr), ($addr)));
	    }' unless defined(&ext2_test_bit);
	    eval 'sub ext2_find_first_zero_bit {
	        my($addr, $size) = @_;
    		eval q( &find_first_zero_bit(($addr), ($size)));
	    }' unless defined(&ext2_find_first_zero_bit);
	    eval 'sub ext2_find_next_zero_bit {
	        my($addr, $size, $offset) = @_;
    		eval q( &find_next_zero_bit(($addr), ($size), ($offset)));
	    }' unless defined(&ext2_find_next_zero_bit);
	} else {
	    eval 'sub ext2_set_bit {
	        my($nr,$addr) = @_;
    		eval q({ \'int\'  &mask,  &retval; my $flags;  &volatile my $char * &ADDR = $addr;  &ADDR += $nr >> 3;  &mask = 1<< ($nr & 0x7);  &save_and_cli( $flags);  &retval = ( &mask & * &ADDR) != 0; * &ADDR |=  &mask;  &restore_flags( $flags);  &retval; });
	    }' unless defined(&ext2_set_bit);
	    eval 'sub ext2_clear_bit {
	        my($nr,$addr) = @_;
    		eval q({ \'int\'  &mask,  &retval; my $flags;  &volatile my $char * &ADDR = $addr;  &ADDR += $nr >> 3;  &mask = 1<< ($nr & 0x7);  &save_and_cli( $flags);  &retval = ( &mask & * &ADDR) != 0; * &ADDR &= ~ &mask;  &restore_flags( $flags);  &retval; });
	    }' unless defined(&ext2_clear_bit);
	    eval 'sub ext2_test_bit {
	        my($nr,$addr) = @_;
    		eval q({ \'int\'  &mask;  &const  &volatile my $char * &ADDR = ( &const my $char *) $addr;  &ADDR += $nr >> 3;  &mask = 1<< ($nr & 0x7); (( &mask & * &ADDR) != 0); });
	    }' unless defined(&ext2_test_bit);
	    eval 'sub ext2_find_first_zero_bit {
	        my($addr, $size) = @_;
    		eval q( &ext2_find_next_zero_bit(($addr), ($size), 0));
	    }' unless defined(&ext2_find_first_zero_bit);
	    eval 'sub ext2_find_next_zero_bit {
	        my($addr,$size,$offset) = @_;
    		eval q({ my $long * &p = ( $addr) + ($offset >> 5); my $result = $offset & ~31; my $tmp;  &if ($offset >= $size) $size; $size -=  $result; $offset &= 31;  &if($offset) {  $tmp = *( &p++);  $tmp |=  &__swab32(~0 >> (32-$offset));  &if($size < 32)  &goto  &found_first;  &if(~ $tmp)  &goto  &found_middle; $size -= 32;  $result += 32; }  &while($size & ~31) {  &if(~( $tmp = *( &p++)))  &goto  &found_middle;  $result += 32; $size -= 32; }  &if(!$size)  $result;  $tmp = * &p;  &found_first:  $result +  &ffz( &__swab32( $tmp) | (~0 << $size));  &found_middle:  $result +  &ffz( &__swab32( $tmp)); });
	    }' unless defined(&ext2_find_next_zero_bit);
	}
	eval 'sub minix_test_and_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_and_set_bit($nr,$addr));
	}' unless defined(&minix_test_and_set_bit);
	eval 'sub minix_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &set_bit($nr,$addr));
	}' unless defined(&minix_set_bit);
	eval 'sub minix_test_and_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_and_clear_bit($nr,$addr));
	}' unless defined(&minix_test_and_clear_bit);
	eval 'sub minix_test_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_bit($nr,$addr));
	}' unless defined(&minix_test_bit);
	eval 'sub minix_find_first_zero_bit {
	    my($addr,$size) = @_;
    	    eval q( &find_first_zero_bit($addr,$size));
	}' unless defined(&minix_find_first_zero_bit);
    }
}
1;
