require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_PAGE_H)) {
    eval 'sub __ASM_SH_PAGE_H () {1;}' unless defined(&__ASM_SH_PAGE_H);
    require 'linux/config.ph';
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {(1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {(~( &PAGE_SIZE-1));}' unless defined(&PAGE_MASK);
    eval 'sub PTE_MASK () { &PAGE_MASK;}' unless defined(&PTE_MASK);
    if(defined(&__KERNEL__)) {
	unless(defined(&__ASSEMBLY__)) {
	    if(defined( &__sh3__)) {
		eval 'sub clear_user_page {
		    my($page, $vaddr) = @_;
    		    eval q( &clear_page($page));
		}' unless defined(&clear_user_page);
		eval 'sub copy_user_page {
		    my($to, $from, $vaddr) = @_;
    		    eval q( &copy_page($to, $from));
		}' unless defined(&copy_user_page);
	    }
 elsif(defined( &__SH4__)) {
	    }
	    eval 'sub pte_val {
	        my($x) = @_;
    		eval q((($x). &pte));
	    }' unless defined(&pte_val);
	    eval 'sub pmd_val {
	        my($x) = @_;
    		eval q((($x). &pmd));
	    }' unless defined(&pmd_val);
	    eval 'sub pgd_val {
	        my($x) = @_;
    		eval q((($x). &pgd));
	    }' unless defined(&pgd_val);
	    eval 'sub pgprot_val {
	        my($x) = @_;
    		eval q((($x). &pgprot));
	    }' unless defined(&pgprot_val);
	    eval 'sub __pte {
	        my($x) = @_;
    		eval q((( &pte_t) { ($x) } ));
	    }' unless defined(&__pte);
	    eval 'sub __pmd {
	        my($x) = @_;
    		eval q((( &pmd_t) { ($x) } ));
	    }' unless defined(&__pmd);
	    eval 'sub __pgd {
	        my($x) = @_;
    		eval q((( &pgd_t) { ($x) } ));
	    }' unless defined(&__pgd);
	    eval 'sub __pgprot {
	        my($x) = @_;
    		eval q((( &pgprot_t) { ($x) } ));
	    }' unless defined(&__pgprot);
	}
	eval 'sub PAGE_ALIGN {
	    my($addr) = @_;
    	    eval q(((($addr)+ &PAGE_SIZE-1) &PAGE_MASK));
	}' unless defined(&PAGE_ALIGN);
	eval 'sub __MEMORY_START () { &CONFIG_MEMORY_START;}' unless defined(&__MEMORY_START);
	eval 'sub __MEMORY_SIZE () { &CONFIG_MEMORY_SIZE;}' unless defined(&__MEMORY_SIZE);
	if(defined(&CONFIG_DISCONTIGMEM)) {
	    eval 'sub __MEMORY_START_2ND () {( &__MEMORY_START+0x2000000);}' unless defined(&__MEMORY_START_2ND);
	    eval 'sub __MEMORY_SIZE_2ND () {0x1000000;}' unless defined(&__MEMORY_SIZE_2ND);
	}
	eval 'sub PAGE_OFFSET () {(0x80000000);}' unless defined(&PAGE_OFFSET);
	eval 'sub __pa {
	    my($x) = @_;
    	    eval q((($x)- &PAGE_OFFSET));
	}' unless defined(&__pa);
	eval 'sub __va {
	    my($x) = @_;
    	    eval q((( &void *)(($x)+ &PAGE_OFFSET)));
	}' unless defined(&__va);
	unless(defined(&CONFIG_DISCONTIGMEM)) {
	    eval 'sub phys_to_page {
	        my($phys) = @_;
    		eval q(( &mem_map + ((($phys)- &__MEMORY_START) >>  &PAGE_SHIFT)));
	    }' unless defined(&phys_to_page);
	    eval 'sub VALID_PAGE {
	        my($page) = @_;
    		eval q((($page -  &mem_map) <  &max_mapnr));
	    }' unless defined(&VALID_PAGE);
	    eval 'sub page_to_phys {
	        my($page) = @_;
    		eval q(((($page -  &mem_map) <<  &PAGE_SHIFT) +  &__MEMORY_START));
	    }' unless defined(&page_to_phys);
	}
	eval 'sub virt_to_page {
	    my($kaddr) = @_;
    	    eval q( &phys_to_page( &__pa($kaddr)));
	}' unless defined(&virt_to_page);
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_EXEC |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub BUG () {
	        eval q( &do {  &printk(\\"kernel BUG at %s:%d!\\\\n\\",  &__FILE__,  &__LINE__);  &asm  &volatile(\\"nop\\"); }  &while (0));
	    }' unless defined(&BUG);
	    eval 'sub PAGE_BUG {
	        my($page) = @_;
    		eval q( &do {  &BUG(); }  &while (0));
	    }' unless defined(&PAGE_BUG);
	}
    }
}
1;
