require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_PGTABLE_H)) {
    eval 'sub __ASM_SH_PGTABLE_H () {1;}' unless defined(&__ASM_SH_PGTABLE_H);
    require 'asm/pgtable-2level.ph';
    unless(defined(&__ASSEMBLY__)) {
	require 'asm/processor.ph';
	require 'asm/addrspace.ph';
	require 'linux/threads.ph';
	if(defined( &__sh3__)) {
	    eval 'sub flush_cache_all () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_all);
	    eval 'sub flush_cache_mm {
	        my($mm) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_mm);
	    eval 'sub flush_cache_range {
	        my($mm, $start, $end) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_range);
	    eval 'sub flush_cache_page {
	        my($vma, $vmaddr) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_page);
	    eval 'sub flush_page_to_ram {
	        my($page) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_page_to_ram);
	    eval 'sub flush_dcache_page {
	        my($page) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_dcache_page);
	    eval 'sub flush_icache_range {
	        my($start, $end) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_icache_range);
	    eval 'sub flush_icache_page {
	        my($vma,$pg) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_icache_page);
	    eval 'sub flush_icache_user_range {
	        my($vma,$pg,$adr,$len) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_icache_user_range);
	    eval 'sub flush_cache_sigtramp {
	        my($vaddr) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_sigtramp);
	    eval 'sub __flush_icache_all () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&__flush_icache_all);
	    eval 'sub p3_cache_init () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&p3_cache_init);
	}
 elsif(defined( &__SH4__)) {
	    eval 'sub CACHE_ALIAS () {0x3000;}' unless defined(&CACHE_ALIAS);
	    eval 'sub flush_page_to_ram {
	        my($page) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_page_to_ram);
	    eval 'sub flush_icache_page {
	        my($vma,$pg) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_icache_page);
	    eval 'sub flush_icache_user_range {
	        my($vma,$pg,$adr,$len) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_icache_user_range);
	    eval 'sub PG_mapped () { &PG_arch_1;}' unless defined(&PG_mapped);
	    eval 'sub HAVE_ARCH_UNMAPPED_AREA () {1;}' unless defined(&HAVE_ARCH_UNMAPPED_AREA);
	}
	eval 'sub ZERO_PAGE {
	    my($vaddr) = @_;
    	    eval q(( &virt_to_page( &empty_zero_page)));
	}' unless defined(&ZERO_PAGE);
    }
    eval 'sub __beep () {
        eval q( &asm(\\"\\"));
    }' unless defined(&__beep);
    eval 'sub PMD_SIZE () {(1 <<  &PMD_SHIFT);}' unless defined(&PMD_SIZE);
    eval 'sub PMD_MASK () {(~( &PMD_SIZE-1));}' unless defined(&PMD_MASK);
    eval 'sub PGDIR_SIZE () {(1 <<  &PGDIR_SHIFT);}' unless defined(&PGDIR_SIZE);
    eval 'sub PGDIR_MASK () {(~( &PGDIR_SIZE-1));}' unless defined(&PGDIR_MASK);
    eval 'sub USER_PTRS_PER_PGD () {( &TASK_SIZE/ &PGDIR_SIZE);}' unless defined(&USER_PTRS_PER_PGD);
    eval 'sub FIRST_USER_PGD_NR () {0;}' unless defined(&FIRST_USER_PGD_NR);
    eval 'sub PTE_PHYS_MASK () {0x1ffff000;}' unless defined(&PTE_PHYS_MASK);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub VMALLOC_START () {( &P3SEG+0x100000);}' unless defined(&VMALLOC_START);
	eval 'sub VMALLOC_VMADDR {
	    my($x) = @_;
    	    eval q((($x)));
	}' unless defined(&VMALLOC_VMADDR);
	eval 'sub VMALLOC_END () { &P4SEG;}' unless defined(&VMALLOC_END);
	eval 'sub _PAGE_HW_SHARED () {0x2;}' unless defined(&_PAGE_HW_SHARED);
	eval 'sub _PAGE_DIRTY () {0x4;}' unless defined(&_PAGE_DIRTY);
	eval 'sub _PAGE_CACHABLE () {0x8;}' unless defined(&_PAGE_CACHABLE);
	eval 'sub _PAGE_RW () {0x20;}' unless defined(&_PAGE_RW);
	eval 'sub _PAGE_USER () {0x40;}' unless defined(&_PAGE_USER);
	eval 'sub _PAGE_PRESENT () {0x100;}' unless defined(&_PAGE_PRESENT);
	eval 'sub _PAGE_PROTNONE () {0x200;}' unless defined(&_PAGE_PROTNONE);
	eval 'sub _PAGE_ACCESSED () {0x400;}' unless defined(&_PAGE_ACCESSED);
	eval 'sub _PAGE_U0_SHARED () {0x800;}' unless defined(&_PAGE_U0_SHARED);
	eval 'sub _PAGE_PCC_AREA5 () {0x;}' unless defined(&_PAGE_PCC_AREA5);
	eval 'sub _PAGE_PCC_AREA6 () {0x80000000;}' unless defined(&_PAGE_PCC_AREA6);
	eval 'sub _PAGE_PCC_IODYN () {0x1;}' unless defined(&_PAGE_PCC_IODYN);
	eval 'sub _PAGE_PCC_IO8 () {0x20000000;}' unless defined(&_PAGE_PCC_IO8);
	eval 'sub _PAGE_PCC_IO16 () {0x20000001;}' unless defined(&_PAGE_PCC_IO16);
	eval 'sub _PAGE_PCC_COM8 () {0x40000000;}' unless defined(&_PAGE_PCC_COM8);
	eval 'sub _PAGE_PCC_COM16 () {0x40000001;}' unless defined(&_PAGE_PCC_COM16);
	eval 'sub _PAGE_PCC_ATR8 () {0x60000000;}' unless defined(&_PAGE_PCC_ATR8);
	eval 'sub _PAGE_PCC_ATR16 () {0x60000001;}' unless defined(&_PAGE_PCC_ATR16);
	if(defined( &__sh3__)) {
	    eval 'sub _PAGE_FLAGS_HARDWARE_MASK () {0x1ffff1fc;}' unless defined(&_PAGE_FLAGS_HARDWARE_MASK);
	} else {
	    eval 'sub _PAGE_FLAGS_HARDWARE_MASK () {0x1ffff1fe;}' unless defined(&_PAGE_FLAGS_HARDWARE_MASK);
	}
	eval 'sub _PAGE_FLAGS_HARD () {0x10;}' unless defined(&_PAGE_FLAGS_HARD);
	eval 'sub _PAGE_SHARED () { &_PAGE_U0_SHARED;}' unless defined(&_PAGE_SHARED);
	eval 'sub _PAGE_TABLE () {( &_PAGE_PRESENT |  &_PAGE_RW |  &_PAGE_USER |  &_PAGE_ACCESSED |  &_PAGE_DIRTY);}' unless defined(&_PAGE_TABLE);
	eval 'sub _KERNPG_TABLE () {( &_PAGE_PRESENT |  &_PAGE_RW |  &_PAGE_ACCESSED |  &_PAGE_DIRTY);}' unless defined(&_KERNPG_TABLE);
	eval 'sub _PAGE_CHG_MASK () {( &PTE_MASK |  &_PAGE_ACCESSED |  &_PAGE_CACHABLE |  &_PAGE_DIRTY |  &_PAGE_SHARED);}' unless defined(&_PAGE_CHG_MASK);
	eval 'sub PAGE_NONE () { &__pgprot( &_PAGE_PROTNONE |  &_PAGE_CACHABLE | &_PAGE_ACCESSED |  &_PAGE_FLAGS_HARD);}' unless defined(&PAGE_NONE);
	eval 'sub PAGE_SHARED () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_RW |  &_PAGE_USER |  &_PAGE_CACHABLE | &_PAGE_ACCESSED |  &_PAGE_SHARED |  &_PAGE_FLAGS_HARD);}' unless defined(&PAGE_SHARED);
	eval 'sub PAGE_COPY () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_USER |  &_PAGE_CACHABLE |  &_PAGE_ACCESSED |  &_PAGE_FLAGS_HARD);}' unless defined(&PAGE_COPY);
	eval 'sub PAGE_READONLY () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_USER |  &_PAGE_CACHABLE |  &_PAGE_ACCESSED |  &_PAGE_FLAGS_HARD);}' unless defined(&PAGE_READONLY);
	eval 'sub PAGE_KERNEL () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_RW |  &_PAGE_CACHABLE |  &_PAGE_DIRTY |  &_PAGE_ACCESSED |  &_PAGE_HW_SHARED |  &_PAGE_FLAGS_HARD);}' unless defined(&PAGE_KERNEL);
	eval 'sub PAGE_KERNEL_RO () { &__pgprot( &_PAGE_PRESENT |  &_PAGE_CACHABLE |  &_PAGE_DIRTY |  &_PAGE_ACCESSED |  &_PAGE_HW_SHARED |  &_PAGE_FLAGS_HARD);}' unless defined(&PAGE_KERNEL_RO);
	eval 'sub PAGE_KERNEL_PCC {
	    my($slot, $type) = @_;
    	    eval q( &__pgprot( &_PAGE_PRESENT |  &_PAGE_RW |  &_PAGE_DIRTY |  &_PAGE_ACCESSED |  &_PAGE_FLAGS_HARD | ($slot ?  &_PAGE_PCC_AREA5 :  &_PAGE_PCC_AREA6) | ($type)));
	}' unless defined(&PAGE_KERNEL_PCC);
	eval 'sub __P000 () { &PAGE_NONE;}' unless defined(&__P000);
	eval 'sub __P001 () { &PAGE_READONLY;}' unless defined(&__P001);
	eval 'sub __P010 () { &PAGE_COPY;}' unless defined(&__P010);
	eval 'sub __P011 () { &PAGE_COPY;}' unless defined(&__P011);
	eval 'sub __P100 () { &PAGE_READONLY;}' unless defined(&__P100);
	eval 'sub __P101 () { &PAGE_READONLY;}' unless defined(&__P101);
	eval 'sub __P110 () { &PAGE_COPY;}' unless defined(&__P110);
	eval 'sub __P111 () { &PAGE_COPY;}' unless defined(&__P111);
	eval 'sub __S000 () { &PAGE_NONE;}' unless defined(&__S000);
	eval 'sub __S001 () { &PAGE_READONLY;}' unless defined(&__S001);
	eval 'sub __S010 () { &PAGE_SHARED;}' unless defined(&__S010);
	eval 'sub __S011 () { &PAGE_SHARED;}' unless defined(&__S011);
	eval 'sub __S100 () { &PAGE_READONLY;}' unless defined(&__S100);
	eval 'sub __S101 () { &PAGE_READONLY;}' unless defined(&__S101);
	eval 'sub __S110 () { &PAGE_SHARED;}' unless defined(&__S110);
	eval 'sub __S111 () { &PAGE_SHARED;}' unless defined(&__S111);
	eval 'sub pte_none {
	    my($x) = @_;
    	    eval q((! &pte_val($x)));
	}' unless defined(&pte_none);
	eval 'sub pte_present {
	    my($x) = @_;
    	    eval q(( &pte_val($x) & ( &_PAGE_PRESENT |  &_PAGE_PROTNONE)));
	}' unless defined(&pte_present);
	eval 'sub pte_clear {
	    my($xp) = @_;
    	    eval q( &do {  &set_pte($xp,  &__pte(0)); }  &while (0));
	}' unless defined(&pte_clear);
	eval 'sub pmd_none {
	    my($x) = @_;
    	    eval q((! &pmd_val($x)));
	}' unless defined(&pmd_none);
	eval 'sub pmd_present {
	    my($x) = @_;
    	    eval q(( &pmd_val($x) &  &_PAGE_PRESENT));
	}' unless defined(&pmd_present);
	eval 'sub pmd_clear {
	    my($xp) = @_;
    	    eval q( &do {  &set_pmd($xp,  &__pmd(0)); }  &while (0));
	}' unless defined(&pmd_clear);
	eval 'sub pmd_bad {
	    my($x) = @_;
    	    eval q((( &pmd_val($x) & (~ &PAGE_MASK & ~ &_PAGE_USER)) !=  &_KERNPG_TABLE));
	}' unless defined(&pmd_bad);
	eval 'sub pages_to_mb {
	    my($x) = @_;
    	    eval q((($x) >> (20- &PAGE_SHIFT)));
	}' unless defined(&pages_to_mb);
	eval 'sub pte_page {
	    my($x) = @_;
    	    eval q( &phys_to_page( &pte_val($x) &PTE_PHYS_MASK));
	}' unless defined(&pte_page);
	eval 'sub page_pte {
	    my($page) = @_;
    	    eval q( &page_pte_prot($page,  &__pgprot(0)));
	}' unless defined(&page_pte);
	eval 'sub pmd_page {
	    my($pmd) = @_;
    	    eval q((  &__va( &pmd_val($pmd) &  &PAGE_MASK)));
	}' unless defined(&pmd_page);
	eval 'sub pgd_index {
	    my($address) = @_;
    	    eval q(((($address) >>  &PGDIR_SHIFT) & ( &PTRS_PER_PGD-1)));
	}' unless defined(&pgd_index);
	eval 'sub __pgd_offset {
	    my($address) = @_;
    	    eval q( &pgd_index($address));
	}' unless defined(&__pgd_offset);
	eval 'sub pgd_offset {
	    my($mm, $address) = @_;
    	    eval q((($mm)-> &pgd+ &pgd_index($address)));
	}' unless defined(&pgd_offset);
	eval 'sub pgd_offset_k {
	    my($address) = @_;
    	    eval q( &pgd_offset( &init_mm, $address));
	}' unless defined(&pgd_offset_k);
	eval 'sub __pte_offset {
	    my($address) = @_;
    	    eval q((($address >>  &PAGE_SHIFT) & ( &PTRS_PER_PTE - 1)));
	}' unless defined(&__pte_offset);
	eval 'sub pte_offset {
	    my($dir, $address) = @_;
    	    eval q((( &pte_t *)  &pmd_page(*($dir)) +  &__pte_offset($address)));
	}' unless defined(&pte_offset);
	eval 'sub SWP_TYPE {
	    my($x) = @_;
    	    eval q((($x). &val & 0xff));
	}' unless defined(&SWP_TYPE);
	eval 'sub SWP_OFFSET {
	    my($x) = @_;
    	    eval q((($x). &val >> 10));
	}' unless defined(&SWP_OFFSET);
	eval 'sub SWP_ENTRY {
	    my($type, $offset) = @_;
    	    eval q((( &swp_entry_t) { ($type) | (($offset) << 10) }));
	}' unless defined(&SWP_ENTRY);
	eval 'sub pte_to_swp_entry {
	    my($pte) = @_;
    	    eval q((( &swp_entry_t) {  &pte_val($pte) }));
	}' unless defined(&pte_to_swp_entry);
	eval 'sub swp_entry_to_pte {
	    my($x) = @_;
    	    eval q((( &pte_t) { ($x). &val }));
	}' unless defined(&swp_entry_to_pte);
	eval 'sub pte_same {
	    my($A,$B) = @_;
    	    eval q(( &pte_val($A) ==  &pte_val($B)));
	}' unless defined(&pte_same);
    }
    eval 'sub PageSkip {
        my($page) = @_;
	    eval q((0));
    }' unless defined(&PageSkip);
    eval 'sub kern_addr_valid {
        my($addr) = @_;
	    eval q((1));
    }' unless defined(&kern_addr_valid);
    eval 'sub io_remap_page_range () { &remap_page_range;}' unless defined(&io_remap_page_range);
    eval 'sub pgtable_cache_init () {
        eval q( &do { }  &while (0));
    }' unless defined(&pgtable_cache_init);
    eval 'sub pgprot_noncached {
        my($_prot) = @_;
	    eval q( &__pgprot( &pgprot_val($_prot) &= ~ &_PAGE_CACHABLE));
    }' unless defined(&pgprot_noncached);
}
1;
