require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_SEMAPHORE_H)) {
    eval 'sub __ASM_SH_SEMAPHORE_H () {1;}' unless defined(&__ASM_SH_SEMAPHORE_H);
    require 'linux/linkage.ph';
    if(defined(&__KERNEL__)) {
	require 'linux/spinlock.ph';
	require 'linux/rwsem.ph';
	require 'asm/system.ph';
	require 'asm/atomic.ph';
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	    eval 'sub __SEM_DEBUG_INIT {
	        my($name) = @_;
    		eval q(, ($name). &__magic);
	    }' unless defined(&__SEM_DEBUG_INIT);
	} else {
	    eval 'sub __SEM_DEBUG_INIT {
	        my($name) = @_;
    		eval q();
	    }' unless defined(&__SEM_DEBUG_INIT);
	}
	eval 'sub __SEMAPHORE_INITIALIZER {
	    my($name,$count) = @_;
    	    eval q({  &ATOMIC_INIT($count), 0,  &__WAIT_QUEUE_HEAD_INITIALIZER(($name). &wait)  &__SEM_DEBUG_INIT($name) });
	}' unless defined(&__SEMAPHORE_INITIALIZER);
	eval 'sub __MUTEX_INITIALIZER {
	    my($name) = @_;
    	    eval q( &__SEMAPHORE_INITIALIZER($name,1));
	}' unless defined(&__MUTEX_INITIALIZER);
	eval 'sub __DECLARE_SEMAPHORE_GENERIC {
	    my($name,$count) = @_;
    	    eval q(\'struct semaphore\' $name =  &__SEMAPHORE_INITIALIZER($name,$count));
	}' unless defined(&__DECLARE_SEMAPHORE_GENERIC);
	eval 'sub DECLARE_MUTEX {
	    my($name) = @_;
    	    eval q( &__DECLARE_SEMAPHORE_GENERIC($name,1));
	}' unless defined(&DECLARE_MUTEX);
	eval 'sub DECLARE_MUTEX_LOCKED {
	    my($name) = @_;
    	    eval q( &__DECLARE_SEMAPHORE_GENERIC($name,0));
	}' unless defined(&DECLARE_MUTEX_LOCKED);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub sema_init {
	    my($sem,$val) = @_;
    	    eval q({  &atomic_set( ($sem->{count}), $val);  ($sem->{sleepers}) = 0;  &init_waitqueue_head( ($sem->{wait})); });
	}' unless defined(&sema_init);
	eval 'sub init_MUTEX {
	    my($sem) = @_;
    	    eval q({  &sema_init($sem, 1); });
	}' unless defined(&init_MUTEX);
	eval 'sub init_MUTEX_LOCKED {
	    my($sem) = @_;
    	    eval q({  &sema_init($sem, 0); });
	}' unless defined(&init_MUTEX_LOCKED);
	if(0) {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub down {
	    my($sem) = @_;
    	    eval q({  &if ( &atomic_dec_return( ($sem->{count})) < 0)  &__down($sem); });
	}' unless defined(&down);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub down_interruptible {
	    my($sem) = @_;
    	    eval q({ \'int\'  &ret = 0;  &if ( &atomic_dec_return( ($sem->{count})) < 0)  &ret =  &__down_interruptible($sem);  &ret; });
	}' unless defined(&down_interruptible);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub down_trylock {
	    my($sem) = @_;
    	    eval q({ \'int\'  &ret = 0;  &if ( &atomic_dec_return( ($sem->{count})) < 0)  &ret =  &__down_trylock($sem);  &ret; });
	}' unless defined(&down_trylock);
	if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : 0)) {
	}
	eval 'sub sem_getcount {
	    my($sem) = @_;
    	    eval q({  &atomic_read( ($sem->{count})); });
	}' unless defined(&sem_getcount);
    }
}
1;
