require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_SYSTEM_H)) {
    eval 'sub __ASM_SH_SYSTEM_H () {1;}' unless defined(&__ASM_SH_SYSTEM_H);
    require 'linux/config.ph';
    require 'linux/kernel.ph';
    if(defined(&CONFIG_SMP)) {
	die("no\ SMP\ SuperH");
    } else {
	eval 'sub prepare_to_switch () {
	    eval q( &do { }  &while(0));
	}' unless defined(&prepare_to_switch);
	eval 'sub switch_to {
	    my($prev,$next,$last) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&switch_to);
    }
    eval 'sub nop () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&nop);
    eval 'sub xchg {
        my($ptr,$x) = @_;
	    eval q((( &__typeof__(*)) &__xchg(($x),($ptr),$sizeof{($ptr)})));
    }' unless defined(&xchg);
    eval 'sub tas {
        my($m) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&tas);
    eval 'sub mb () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&mb);
    eval 'sub rmb () {
        eval q( &mb());
    }' unless defined(&rmb);
    eval 'sub wmb () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&wmb);
    if(defined(&CONFIG_SMP)) {
	eval 'sub smp_mb () {
	    eval q( &mb());
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &rmb());
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &wmb());
	}' unless defined(&smp_wmb);
    } else {
	eval 'sub smp_mb () {
	    eval q( &barrier());
	}' unless defined(&smp_mb);
	eval 'sub smp_rmb () {
	    eval q( &barrier());
	}' unless defined(&smp_rmb);
	eval 'sub smp_wmb () {
	    eval q( &barrier());
	}' unless defined(&smp_wmb);
    }
    eval 'sub set_mb {
        my($var, $value) = @_;
	    eval q( &do { $var = $value;  &mb(); }  &while (0));
    }' unless defined(&set_mb);
    eval 'sub set_wmb {
        my($var, $value) = @_;
	    eval q( &do { $var = $value;  &wmb(); }  &while (0));
    }' unless defined(&set_wmb);
    eval 'sub __cli {
        my($void) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__cli);
    eval 'sub __save_flags {
        my($x) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__save_flags);
    eval 'sub __save_and_cli {
        my($void) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__save_and_cli);
    if(defined(&DEBUG_CLI_STI)) {
	eval 'sub __restore_flags {
	    my($x) = @_;
    	    eval q({  &if (($x & 0xf0) != 0xf0)  &__sti();  &else { my $flags;  &__save_flags( $flags);  &if ( $flags == 0) {  &void  &dump_stack( &void);  &printk( &KERN_ERR \\"BUG!\\\\n\\");  &dump_stack();  &__cli(); } } });
	}' unless defined(&__restore_flags);
    } else {
	eval 'sub __restore_flags {
	    my($x) = @_;
    	    eval q( &do {  &if (($x & 0xf0) != 0xf0)  &__sti(); }  &while (0));
	}' unless defined(&__restore_flags);
    }
    eval 'sub really_restore_flags {
        my($x) = @_;
	    eval q( &do {  &if (($x & 0xf0) != 0xf0)  &__sti();  &else  &__cli(); }  &while (0));
    }' unless defined(&really_restore_flags);
    eval 'sub jump_to_P2 () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&jump_to_P2);
    eval 'sub back_to_P1 () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&back_to_P1);
    eval 'sub __save_and_sti {
        my($x) = @_;
	    eval q( &do {  &__save_flags($x);  &__sti(); }  &while(0););
    }' unless defined(&__save_and_sti);
    eval 'sub local_irq_save {
        my($x) = @_;
	    eval q($x =  &__save_and_cli());
    }' unless defined(&local_irq_save);
    eval 'sub local_irq_set {
        my($x) = @_;
	    eval q( &__save_and_sti($x));
    }' unless defined(&local_irq_set);
    eval 'sub local_irq_restore {
        my($x) = @_;
	    eval q( &__restore_flags($x));
    }' unless defined(&local_irq_restore);
    eval 'sub local_irq_disable () {
        eval q( &__cli());
    }' unless defined(&local_irq_disable);
    eval 'sub local_irq_enable () {
        eval q( &__sti());
    }' unless defined(&local_irq_enable);
    if(defined(&CONFIG_SMP)) {
	eval 'sub cli () {
	    eval q( &__global_cli());
	}' unless defined(&cli);
	eval 'sub sti () {
	    eval q( &__global_sti());
	}' unless defined(&sti);
	eval 'sub save_flags {
	    my($x) = @_;
    	    eval q((($x)= &__global_save_flags()));
	}' unless defined(&save_flags);
	eval 'sub restore_flags {
	    my($x) = @_;
    	    eval q( &__global_restore_flags($x));
	}' unless defined(&restore_flags);
	eval 'sub save_and_sti {
	    my($x) = @_;
    	    eval q( &do {  &save_flags($x);  &sti(); }  &while(0););
	}' unless defined(&save_and_sti);
    } else {
	eval 'sub cli () {
	    eval q( &__cli());
	}' unless defined(&cli);
	eval 'sub sti () {
	    eval q( &__sti());
	}' unless defined(&sti);
	eval 'sub save_flags {
	    my($x) = @_;
    	    eval q( &__save_flags($x));
	}' unless defined(&save_flags);
	eval 'sub save_and_cli {
	    my($x) = @_;
    	    eval q($x =  &__save_and_cli());
	}' unless defined(&save_and_cli);
	eval 'sub save_and_sti {
	    my($x) = @_;
    	    eval q( &__save_and_sti($x));
	}' unless defined(&save_and_sti);
	eval 'sub restore_flags {
	    my($x) = @_;
    	    eval q( &__restore_flags($x));
	}' unless defined(&restore_flags);
    }
    eval 'sub xchg_u32 {
        my($m,$val) = @_;
	    eval q({ my $flags,  &retval;  &save_and_cli( $flags);  &retval = *$m; *$m = $val;  &restore_flags( $flags);  &retval; });
    }' unless defined(&xchg_u32);
    eval 'sub xchg_u8 {
        my($m,$val) = @_;
	    eval q({ my $flags,  &retval;  &save_and_cli( $flags);  &retval = *$m; *$m = $val & 0xff;  &restore_flags( $flags);  &retval; });
    }' unless defined(&xchg_u8);
    eval 'sub __xchg {
        my($x,$ptr,$size) = @_;
	    eval q({  &switch ($size) {  &case 4:  &xchg_u32($ptr, $x);  &break;  &case 1:  &xchg_u8($ptr, $x);  &break; }  &__xchg_called_with_bad_pointer(); $x; });
    }' unless defined(&__xchg);
    eval 'sub HAVE_DISABLE_HLT () {1;}' unless defined(&HAVE_DISABLE_HLT);
}
1;
