require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SH_UACCESS_H)) {
    eval 'sub __ASM_SH_UACCESS_H () {1;}' unless defined(&__ASM_SH_UACCESS_H);
    require 'linux/errno.ph';
    require 'linux/sched.ph';
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    eval 'sub MAKE_MM_SEG {
        my($s) = @_;
	    eval q((( &mm_segment_t) { ($s) }));
    }' unless defined(&MAKE_MM_SEG);
    eval 'sub KERNEL_DS () { &MAKE_MM_SEG(0xffffffff);}' unless defined(&KERNEL_DS);
    eval 'sub USER_DS () { &MAKE_MM_SEG(0x80000000);}' unless defined(&USER_DS);
    eval 'sub get_ds () {
        eval q(( &KERNEL_DS));
    }' unless defined(&get_ds);
    eval 'sub get_fs () {
        eval q(( ($current->{addr_limit})));
    }' unless defined(&get_fs);
    eval 'sub set_fs {
        my($x) = @_;
	    eval q(( ($current->{addr_limit})=($x)));
    }' unless defined(&set_fs);
    eval 'sub segment_eq {
        my($a,$b) = @_;
	    eval q((($a). &seg == ($b). &seg));
    }' unless defined(&segment_eq);
    eval 'sub __addr_ok {
        my($addr) = @_;
	    eval q((($addr) < ( ($current->{addr_limit}->{seg}))));
    }' unless defined(&__addr_ok);
    eval 'sub __range_ok {
        my($addr,$size) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__range_ok);
    eval 'sub access_ok {
        my($type,$addr,$size) = @_;
	    eval q(( &__range_ok($addr,$size) == 0));
    }' unless defined(&access_ok);
    eval 'sub __access_ok {
        my($addr,$size) = @_;
	    eval q(( &__range_ok($addr,$size) == 0));
    }' unless defined(&__access_ok);
    eval 'sub verify_area {
        my($type,$addr,$size) = @_;
	    eval q({  &access_ok($type,$addr,$size) ? 0: - &EFAULT; });
    }' unless defined(&verify_area);
    eval 'sub put_user {
        my($x,$ptr) = @_;
	    eval q( &__put_user_check(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&put_user);
    eval 'sub get_user {
        my($x,$ptr) = @_;
	    eval q( &__get_user_check(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&get_user);
    eval 'sub __put_user {
        my($x,$ptr) = @_;
	    eval q( &__put_user_nocheck(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&__put_user);
    eval 'sub __get_user {
        my($x,$ptr) = @_;
	    eval q( &__get_user_nocheck(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&__get_user);
    eval 'sub __m {
        my($x) = @_;
	    eval q((*($x)));
    }' unless defined(&__m);
    eval 'sub __get_user_nocheck {
        my($x,$ptr,$size) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__get_user_nocheck);
    eval 'sub __get_user_check {
        my($x,$ptr,$size) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__get_user_check);
    eval 'sub __get_user_asm {
        my($insn) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__get_user_asm);
    eval 'sub __put_user_nocheck {
        my($x,$ptr,$size) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_nocheck);
    eval 'sub __put_user_check {
        my($x,$ptr,$size) = @_;
	    eval q(({ \'long __pu_err\' = - &EFAULT;  &__typeof__(*)  &__pu_val; \'long __pu_addr\';  &__pu_val = ;  &__pu_addr = ($ptr);  &if ( &__access_ok( &__pu_addr,$size)) {  &switch ($size) {  &case 1:  &__put_user_asm(\\"b\\");  &break;  &case 2:  &__put_user_asm(\\"w\\");  &break;  &case 4:  &__put_user_asm(\\"l\\");  &break;  &case 8:  &__put_user_u64( &__pu_val, &__pu_addr, &__pu_err);  &break;  &default:  &__put_user_unknown();  &break; } }  &__pu_err; }));
    }' unless defined(&__put_user_check);
    eval 'sub __put_user_asm {
        my($insn) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__put_user_asm);
    if(defined( &__LITTLE_ENDIAN__)) {
	eval 'sub __put_user_u64 {
	    my($val,$addr,$retval) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__put_user_u64);
    } else {
	eval 'sub __put_user_u64 {
	    my($val,$addr,$retval) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__put_user_u64);
    }
    eval 'sub copy_to_user {
        my($to,$from,$n) = @_;
	    eval q(({  &void * &__copy_to = ( &void *) ($to);  &__kernel_size_t  &__copy_size = ( &__kernel_size_t) ;  &__kernel_size_t  &__copy_res;  &if( &__copy_size  &&  &__access_ok( &__copy_to,  &__copy_size)) {  &__copy_res =  &__copy_user( &__copy_to, ( &void *) ($from),  &__copy_size); }  &else  &__copy_res =  &__copy_size;  &__copy_res; }));
    }' unless defined(&copy_to_user);
    eval 'sub __copy_to_user {
        my($to,$from,$n) = @_;
	    eval q( &__copy_user(( &void *)($to), ( &void *)($from), $n));
    }' unless defined(&__copy_to_user);
    eval 'sub copy_from_user {
        my($to,$from,$n) = @_;
	    eval q(({  &void * &__copy_to = ( &void *) ($to);  &void * &__copy_from = ( &void *) ($from);  &__kernel_size_t  &__copy_size = ( &__kernel_size_t) ;  &__kernel_size_t  &__copy_res;  &if( &__copy_size  &&  &__access_ok( &__copy_from,  &__copy_size)) {  &__copy_res =  &__copy_user( &__copy_to,  &__copy_from,  &__copy_size); }  &else  &__copy_res =  &__copy_size;  &__copy_res; }));
    }' unless defined(&copy_from_user);
    eval 'sub __copy_from_user {
        my($to,$from,$n) = @_;
	    eval q( &__copy_user(( &void *)($to), ( &void *)($from), $n));
    }' unless defined(&__copy_from_user);
    eval 'sub clear_user {
        my($addr,$n) = @_;
	    eval q(({  &void *  &__cl_addr = ; \'unsigned long __cl_size\' = ;  &if ( &__cl_size  &&  &__access_ok((( &__cl_addr)),  &__cl_size))  &__cl_size =  &__clear_user( &__cl_addr,  &__cl_size);  &__cl_size; }));
    }' unless defined(&clear_user);
    eval 'sub __strncpy_from_user {
        my($__dest,$__src,$__count) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__strncpy_from_user);
    eval 'sub strncpy_from_user {
        my($dest,$src,$count) = @_;
	    eval q(({ \'unsigned long __sfu_src\' = ; \'int\'  &__sfu_count = ; \'long __sfu_res\' = - &EFAULT;  &if( &__access_ok( &__sfu_src,  &__sfu_count)) {  &__sfu_res =  &__strncpy_from_user( ($dest),  &__sfu_src,  &__sfu_count); }  &__sfu_res; }));
    }' unless defined(&strncpy_from_user);
    eval 'sub strnlen_user {
        my($s,$n) = @_;
	    eval q({  &if (! &access_ok( &VERIFY_READ, $s, $n)) 0;  &else  &__strnlen_user($s, $n); });
    }' unless defined(&strnlen_user);
    eval 'sub strlen_user {
        my($s) = @_;
	    eval q({  &if (! &access_ok( &VERIFY_READ, $s, 0)) 0;  &else  &__strnlen_user($s, ~0 >> 1); });
    }' unless defined(&strlen_user);
    eval 'sub fixup_exception {
        my($map_reg, $fixup_unit, $pc) = @_;
	    eval q(({ $fixup_unit; }));
    }' unless defined(&fixup_exception);
}
1;
